<template>
  <v-layout>
    <v-navigation-drawer
      app
      clipped
      right
      width="350px"
    >
      <Search 
        :origin.sync="origin"
        :destination.sync="destination"
      />

      <v-divider />

      <RouteInstructions
        :instructions="route.instructions"
        :distance="route.distance"
        :duration="route.time"
        v-if="route"
      />
    </v-navigation-drawer>

    <l-map :zoom="zoom" :center="center" :contextmenu="true" ref="mapRef" @ready="mapLoaded">
      <l-geo-json :geojson="area.geojson" :options="area.options" />
      <l-tile-layer :url="url" :attribution="attribution"></l-tile-layer>

      <l-geo-json :geojson="route.points" v-if="route" />
      <l-marker :draggable="true" :lat-lng.sync="origin" v-if="origin"></l-marker>
      <l-marker :draggable="true" :lat-lng.sync="destination" v-if="destination"></l-marker>
    </l-map>
  </v-layout>
</template>

<script lang="ts">
import { Vue, Component, Prop, Watch } from 'vue-property-decorator';
import { LatLng } from 'leaflet';
import * as L from 'leaflet';
import { LMap, LMarker, LTileLayer, LGeoJson } from 'vue2-leaflet';
import 'leaflet.snogylop';
import 'leaflet-contextmenu';

import 'leaflet/dist/leaflet.css';
import 'leaflet-contextmenu/dist/leaflet.contextmenu.css';

import CoveredArea from '@/data/covered_area.json';
import { Route, RoutingService, RouteProfile } from '@/services/RoutingService';
import RouteInstructions from '@/components/RouteInstructions.vue';
import Search from '@/components/Search.vue';

@Component({
  components: {
    RouteInstructions, LMap, LMarker, LTileLayer, LGeoJson, Search,
  },
})
export default class Map extends Vue {
  private zoom = 12;
  private center = new LatLng(51.45732284495817, -2.5999832153320312);
  private url = 'https://{s}.tile.osm.org/{z}/{x}/{y}.png';
  private attribution = '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors';
  private area = {
    geojson: CoveredArea,
    options: {
      color: '#000',
      fillColor: '#000',
      fillOpacity: 0.4,
      invert: true,
      opacity: 0.2,
    },
  };

  private origin: LatLng | null = null;
  private destination: LatLng | null = null;
  private route: Route | null = null;
  private routing = new RoutingService();

  @Watch('origin')
  public onOriginChanged(val: LatLng, oldVal: LatLng | null) {
    this.calculateRoute();
  }

  @Watch('destination')
  public onDestinationChanged(val: LatLng, oldVal: LatLng | null) {
    this.calculateRoute();
  }

  public mounted() {
    this.$store.commit('CLEAR_TITLE');
  }

  public async calculateRoute() {
    if (this.origin && this.destination) {
      this.route = await this.routing.getRoute(this.origin, this.destination, RouteProfile.POLLUTION);
    }
  }

  public mapLoaded(mapObject: L.Map) {
    // Add context menu
    // @ts-ignore
    mapObject.options.contextmenu = true;
    // @ts-ignore
    mapObject.contextmenu.addItem(
        {
          text: 'Set origin',
          callback: this.setOrigin,
        },
    );
    // @ts-ignore
    mapObject.contextmenu.addItem(
        {
          text: 'Set destination',
          callback: this.setDestination,
        },
    );
    // @ts-ignore
    mapObject.contextmenu.enable();
  }

  public setOrigin(event: L.LeafletMouseEvent) {
    this.origin = event.latlng;
  }

  public setDestination(event: L.LeafletMouseEvent) {
    this.destination = event.latlng;
  }
}
</script>

<style lang="sass">
  .v-overlay__content
    height: 100%
    overflow: scroll

  .leaflet-container
    position: absolute
    top: 0
    right: 0
    bottom: 0
    left: 0

  .dense
    .v-text-field
      padding-top: 0
    .v-text-field
      margin-bottom: 0
    &.v-card__text
      padding-bottom: 0
</style>
